Foxit PDF SDK

Public Member Functions | List of all members
foxit::pdf::annots::IconProviderCallback Class Referenceabstract

## Public Member Functions
virtual bool | CanChangeColor (Annot::Type annot_type, const char *icon_name)
| A callback function used to check if current icon provider supports to change color for a specified type. More...
virtual float | GetDisplayHeight (Annot::Type annot_type, const char *icon_name)
| A callback function used to get the height for display of a specified icon, in device size(pixel normally). More...
virtual float | GetDisplayWidth (Annot::Type annot_type, const char *icon_name)
| A callback function used to get the width for display of a specified icon, in device size(pixel normally). More...
virtual PDFPage | GetIcon (Annot::Type annot_type, const char *icon_name, ARGB color, foxit::pdf::objects::PDFDictionary *annot_dict)
| A callback function used to get the icon as PDF page contents for a specified type. More...
virtual String | GetProviderID ()
| A callback function used to get provider ID. More...
virtual String | GetProviderVersion ()
| A callback function used to get provider version. More...
virtual bool | GetShadingColor (Annot::Type annot_type, const char *icon_name, RGB referenced_color, int shading_index, ShadingColor &out_shading_color)
| A callback function used to get the shading colors if current icon provider supports for a specified type. Currently, only support Type-2 shading settings with two color values. More...
virtual bool | HasIcon (Annot::Type annot_type, const char *icon_name)
| A callback function used to check if current icon provider supports icon for a specified type. More...
virtual void | Release ()=0
| A callback function used to release current callback object itself. More...

## Detailed Description

This class represents a callback object as customized annotation icon provider. All the functions in this class are used as callback functions. Pure virtual functions should be implemented by user and user can also choose to implement some or all the reset virtual functions when necessary. Icon provider can only be used for note, file attachment, stamp annotations.
Icon provider's ID and version are treated as the name of the icon provider, so please offer different "ID + version" for different icon providers by callback functions IconProviderCallback::GetProviderID and IconProviderCallback::GetProviderVersion.

## Member Function Documentation

## ◆ CanChangeColor()

virtual bool foxit::pdf::annots::IconProviderCallback::CanChangeColor | ( | Annot::Type | annot_type,
|  | const char * | icon_name
| ) |  |
| inline virtual

A callback function used to check if current icon provider supports to change color for a specified type.

Parameters

  [in] | annot_type | The annotation type. It should be one of Annot::e_Note, Annot::e_FileAttachment and Annot::e_Stamp.
  [in] | icon_name | Icon name of the annotation.

Returns
  true means current icon provider supports to change color for a specified icon type, while false means not support.

## ◆ GetDisplayHeight()

virtual float foxit::pdf::annots::IconProviderCallback::GetDisplayHeight | ( | Annot::Type | annot_type,
|  | const char * | icon_name
| ) |  |
| inline virtual

A callback function used to get the height for display of a specified icon, in device size(pixel normally).

Parameters

  [in] | annot_type | The annotation type. It should be one of Annot::e_Note, Annot::e_FileAttachment and Annot::e_Stamp.
  [in] | icon_name | Icon name of the annotation.

Returns
  The height for display.

## ◆ GetDisplayWidth()

virtual float foxit::pdf::annots::IconProviderCallback::GetDisplayWidth | ( | Annot::Type | annot_type,
|  | const char * | icon_name
| ) |  |
| inline virtual

A callback function used to get the width for display of a specified icon, in device size(pixel normally).

Parameters

  [in] | annot_type | The annotation type. It should be one of Annot::e_Note, Annot::e_FileAttachment and Annot::e_Stamp.
  [in] | icon_name | Icon name of the annotation.

Returns
  The width for display.

## ◆ GetIcon()

virtual PDFPage foxit::pdf::annots::IconProviderCallback::GetIcon | ( | Annot::Type | annot_type,
|  | const char * | icon_name,
|  | ARGB | color,
|  | foxit::pdf::objects::PDFDictionary * | annot_dict
| ) |  |
| virtual

A callback function used to get the icon as PDF page contents for a specified type.

Parameters

  [in] | annot_type | The annotation type. It should be one of Annot::e_Note, Annot::e_FileAttachment and Annot::e_Stamp.
  [in] | icon_name | Icon name of the annotation.
  [in] | color | The icon color of the annotation. Format: 0xAARRGGBB.
  [in] | annot_dict | The annotation dictionary.

Returns
  A PDF page object whose content would be used as the icon.

## ◆ GetProviderID()

virtual String foxit::pdf::annots::IconProviderCallback::GetProviderID | ( |  | ) |
| inline virtual

A callback function used to get provider ID.

Icon provider's ID and version are treated as the name of the icon provider, so please offer different "ID + version" for different icon providers.

Returns
  The provider ID.

## ◆ GetProviderVersion()

virtual String foxit::pdf::annots::IconProviderCallback::GetProviderVersion | ( |  | ) |
| inline virtual

A callback function used to get provider version.

Icon provider's ID and version are treated as the name of the icon provider, so please offer different "ID + version" for different icon providers.

Returns
  Version string.

## ◆ GetShadingColor()

virtual bool foxit::pdf::annots::IconProviderCallback::GetShadingColor | ( | Annot::Type | annot_type,
|  | const char * | icon_name,
|  | RGB | referenced_color,
|  | int | shading_index,
|  | ShadingColor & | out_shading_color
| ) |  |
| inline virtual

A callback function used to get the shading colors if current icon provider supports for a specified type. Currently, only support Type-2 shading settings with two color values.

Parameters

  [in] | annot_type | The annotation type. It should be one of Annot::e_Note, Annot::e_FileAttachment and Annot::e_Stamp.
  [in] | icon_name | Icon name of the annotation.
  [in] | referenced_color | Referenced color. Format: 0xRRGGBB.
  [in] | shading_index | Index color of shading, starting from 0. If shading colors are more than one, this function will be called multiple times.
  [out] | out_shading_color | Output parameter that receives the two shading color value.

Returns
  true means success, while false means failure.

## ◆ HasIcon()

virtual bool foxit::pdf::annots::IconProviderCallback::HasIcon | ( | Annot::Type | annot_type,
|  | const char * | icon_name
| ) |  |
| inline virtual

A callback function used to check if current icon provider supports icon for a specified type.

Parameters

  [in] | annot_type | The annotation type. It should be one of Annot::e_Note, Annot::e_FileAttachment and Annot::e_Stamp.
  [in] | icon_name | Icon name of the annotation.

Returns
  true means current icon provider supports the specified icon, while false means not support.

## ◆ Release()

virtual void foxit::pdf::annots::IconProviderCallback::Release | ( |  | ) |
| pure virtual

A callback function used to release current callback object itself.

Returns
  None.